export function persist(storage, options = {}) {
    const { syncTabs = false, root = false } = options;
    const { set, initialValue, defaultValue, event } = storage;
    let state = $state(initialValue);
    const syncWithStorage = () => {
        $effect(() => set(state));
    };
    const listenStorage = (value) => (state = value);
    let cleanup = () => { };
    if (root) {
        cleanup = $effect.root(() => {
            syncWithStorage();
            if (syncTabs) {
                return event?.root ? event.root(listenStorage) : () => { };
            }
        });
    }
    else {
        syncWithStorage();
        if (syncTabs) {
            $effect(() => {
                return event?.component ? event.component(listenStorage) : () => { };
            });
        }
    }
    return {
        get value() {
            return state;
        },
        set value(value) {
            state = value;
        },
        cleanup,
        reset: () => {
            state = defaultValue;
        },
    };
}
